/***************************************************************************
                          map_sample.cpp  -  description
                             -------------------
    begin                : Sat Feb 23 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "map_sample.h"
#include <fstream>
#include "config.h"
#include "map.h"
#include "resources.h"
#include "game.h"
#include "player.h"
#include "maptile_normal.h"
#include "maptile_empty.h"
#include "maptile_bar.h"
#include "maptile_hideout.h"
#include "maptile_slime.h"
#include "maptile_water.h"
#include "maptile_concrete.h"
#include "maptile_ladder.h"
#include "maptile_move.h"
#include "maptile_once.h"
#include "maptile_door.h"
#include "maptile_teleporter.h"
#include "tool_befudlementgas.h"
#include "tool_gold.h"
#include "tool_bomb.h"
#include "tool_bbomb.h"
#include "tool_abomb.h"
#include "tool_key.h"
#include "tool_pickaxe.h"
#include "tool_slimebucket.h"
#include "tool_exploder.h"
#include "tool_life.h"
#include "tool_trap.h"
#include "tool_jackhammer.h"
#include "tool_syringe.h"
#include "tool_lasertripmine.h"
#include "tool_acid.h"
#include "monk.h"


Map_Sample::Map_Sample(Game* _game)
{
	dummy=new Dummy(0,0,this);
	game=_game;
	nl=false;
	id=Config::get_last_level()-1;
	map=0;
  n=false;
	if(game->get_t()==true)
	p2=new Player(0,0,1, this);
	else
	p2=NULL;

  restart=false;

	p1=new Player(0,0,0, this);
  gold=false;
	read_next(id);
}
Map_Sample::~Map_Sample()
{
}
void Map_Sample::show()
{
  if(!n && map)
	{
  map->show();

	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
    m->show();
  }

	map->show_olayer();
  }
}
Gameobject* Map_Sample::get_gameobject(int _x, int _y)
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(_x==m->get_x() && _y==m->get_y() && m->get_type()!=PLAYER)
	  return m;
  }
	return dummy;
}
Gameobject* Map_Sample::get_map_gameobject(int _x, int _y)
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(_x==m->map_x(16) && _y==m->map_y(16))
	  return m;
  }

	return dummy;
}
Gameobject* Map_Sample::get_gameobjectg(int _x, int _y)
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(_x==m->map_x(16) && _y==m->map_y(16) && m->get_type()==MONK)
	  return m;
  }
	return dummy;
}
bool Map_Sample::get_monkih(int _x, int _y)
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(_x==m->map_x(16) && _y==m->map_y(16) && m->get_type()==MONK)
	  {
	  	if((static_cast <Monk*> (m))->in_hole())
	  	return true;
  	}
  }
	return false;
}
Tool* Map_Sample::get_tool(int _x, int _y)
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(m->get_type()==TOOL && _x==m->get_x() && _y==m->get_y())
	  return static_cast <Tool*> (m);
  }
	return static_cast <Tool*> (dummy);
}
bool Map_Sample::no_gold()
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(m->get_type()==TOOL)
	  if((static_cast <Tool*> (m))->get_ttype()==TGOLD)
	  return false;
  }
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  if(m->get_type()==MONK)
	  if((static_cast <Monk*> (m))->have_g()==true)
	  return false;
  }

	return true;
}
void Map_Sample::clean_obj()
{
	list<Gameobject*>::iterator it;
	for(it=objects.begin(); it!=objects.end(); ++it)
	{
    Gameobject *m=*it;
	  m->set_delme();
  }
}
void Map_Sample::act()
{
  if(!n && map)
  {

  if(!gold && no_gold())
  {
    gold=true;
    Resources::Levelready()->play();
  }

  map->act();

  if(CL_Keyboard::get_keycode(CL_KEY_LCTRL) && CL_Keyboard::get_keycode(CL_KEY_R))
  {
    read_next(id);
    restart=true;
  }

  list<Gameobject*>::iterator it=objects.begin();
  while (it!=objects.end())
  {
    /* erase invalidates the iterator, so make a copy to operate on
       and increment it beforehand */
    list<Gameobject*>::iterator g=it;
    it++;
    if(!(*g)->delete_me())
      (*g)->act();
    else
    {
      objects.erase(g);
      objects.sort();
    }
   }
  }

  if(n==true)
  {
     read_next(get_id()+1);
     n=false;
  }
}
void Map_Sample::next()
{
  n=true;
  restart=false;
}
void Map_Sample::read_next(int _id)
{
  gold=false;

	CL_String mapfile="";
	id=_id;

	if(Config::get_last_levelset()!="default")
	mapfile=Resources::custom_path+"levels/"+Config::get_last_levelset()+"/level"+id+".lvl";
	else
	mapfile=Resources::datapath+"levels/"+Config::get_last_levelset()+"/level"+id+".lvl";

	ifstream in(mapfile.get_string());
	char last;
	bool have_p2=false;
	CL_String a="";
	int x=32, y=0, c=-1, max_m=0, w=0;

	in>>w;
	in>>c;

	if(c==-1)
	{
		nl=true;
		return;
	}

 	clean_obj();

	p1->reset();

	if(game->get_t())
	p2->reset();


	if(map)
	delete map;

	map=new Map((WorldType)(w), game);

	//the following is very poor, look away, I should made a function like int read_val();, but this works :)

	while(!in.eof())
	{
		last=in.get();
		char buf[2];
		buf[0] = last;
		buf[1] = 0;
		a=buf;

		if(!in.eof())
		{
			if(last==10)
			{
			y=y+32;
			x=32;
		}

		if(a=="g")
		{
			int t=0;

			last=in.get();

			t+=last;
			t=t-48;

			new Tool_gold(x, y, t, this);
		}
		else if(a=="k")
		{
			int t=0;

			last=in.get();

			t+=last;
			t=t-48;

			new Tool_key(x, y, t, this);
		}
		else if(a=="b")
		{
			int t=0;

			last=in.get();
			t+=last;
			t=t-48;

			if(t==0)
				new Tool_bomb(x, y, this);
			else if(t==1)
				new Tool_bbomb(x, y, this);
			else
				new Tool_abomb(x, y, this);
		}
		else if(a=="n")
		{
			int dx=0;
			int dy=0;

      last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dx=dx*10;
					dx+=last;
					dx=dx-48;
				}
			}

      last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dy=dy*10;
					dy+=last;
					dy=dy-48;
				}
			}

      dx=dx*32;
      dy=dy*32;

      if(dx!=0)
      {
        dx+=32;
        dy+=32;
      }

			new Monk(x, y, dx, dy, this);
		}
		else if(a=="p")
		{
			new Tool_befudlementgas(x, y, this);
		}
		else if(a=="i")
		{
			new Tool_pickaxe(x, y, this);
		}
		else if(a=="j")
		{
			new Tool_jackhammer(x, y, this);
		}
		else if(a=="x")
		{
			new Tool_exploder(x, y, this);
		}
		else if(a=="s")
		{
			new Tool_slimebucket(x, y, this);
		}
		else if(a=="l")
		{
			new Tool_life(x, y, this);
		}
		else if(a=="y")
		{
			new Tool_syringe(x, y, this);
		}
		else if(a=="a")
		{
			new Tool_acid(x, y, this);
		}
		else if(a=="t")
		{
			new Tool_trap(x, y, this);
		}
		else if(a=="m")
		{
			new Tool_lasertripmine(x, y, this);
		}
		else if(a=="B")
		{
			new Maptile_bar(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="C")
		{
			new Maptile_concrete(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="H")
		{
			new Maptile_hideout(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="S")
		{
			new Maptile_slime(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="W")
		{
			new Maptile_water(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="O")
		{
			new Maptile_once(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a==" ")
		{
			new Maptile_empty(x, y, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="L")
		{
			last=in.get();
			bool hidden=false;
			if(last==49)
			hidden=true;

			new Maptile_ladder(x, y, hidden, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="N")
		{
			bool falling=false;
			bool ladder=false;

			last=in.get();
			if(last==49)
			falling=true;

			last=in.get();
			if(last==49)
			ladder=true;

			new Maptile_normal(x, y, falling, ladder, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="M")
		{
			int time=0;

      last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					time=time*10;
					time+=last;
					time=time-48;
				}
			}


      if(time>max_m)
      max_m=time;

			new Maptile_move(x, y, time, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="T")
		{
			int dest=0;
			int tid=0;

			last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					tid=tid*10;
					tid+=last;
					tid=tid-48;
				}
			}
			
			last=0;
			while(last!=44)
			{
				last=in.get();
				if(last!=44)
				{
					dest=dest*10;
					dest+=last;
					dest=dest-48;
				}
			}
			new Maptile_teleporter(x, y, tid, dest, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="D")
		{
			int dtype=0;

			last=in.get();
			dtype+=last;
			dtype=dtype-48;

			new Maptile_door(x, y, dtype, (WorldType)(w), map);
			x=x+32;
		}
		else if(a=="P")
		{
			int id=0;
			last=in.get();
			id+=last;
			id=id-48;


		if(id==0)
		{
			p1->set_s(x, y);
		}
		else
		{
			if(game->get_t()==true)
			{
				p2->set_s(x, y);
				have_p2=true;
			}
		else
		have_p2=true;
		}
		}
	}
	}
	if(have_p2==false && game->get_t()==true)
	{
		p2->set_s(p1->get_x(), p1->get_y());
	}

	map->set_max_m(max_m);
	map->fit();

  if(!restart)
  {
	  this->p1->gain_life();	
	  if(this->map->game->get_t()==true)
	  this->p2->gain_life();
  }
  restart=false;
}
bool Map_Sample::no_left()
{
	return nl;
}
int Map_Sample::get_id()
{
	return id;
}
void Map_Sample::kill(int _x, int _y)
{
	if(this->p1->map_x(16)==_x && this->p1->map_y(16)==_y)
	this->p1->die();	

	if(this->map->game->get_t()==true)
	if(this->p2->map_x(16)==_x && this->p2->map_y(16)==_y)
	this->p2->die();

	if(get_gameobjectg(_x, _y)->get_type()==MONK)
	static_cast <Monk*> (get_gameobjectg(_x, _y))->die();
}
bool Map_Sample::get_gameobjectp(int _x, int _y)
{
	if(this->p1->map_x(16)==_x && this->p1->map_y(16)==_y)
	return true;

	if(this->map->game->get_t()==true)
	if(this->p2->map_x(16)==_x && this->p2->map_y(16)==_y)
	return true;

	return false;
}                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              //Del by KDevelop:                                                                                      //Del by KDevelop:                                                                                                                                          //Del by KDevelop:                                                                                                                                                                                                                       //Del by KDevelop:                                                                                                                                                                                                                                                                                                                                                                               //Del by KDevelop: